package com.yunzhi.marketing.xlk.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 组织结构表 
 * </p>
 *
 * @author jobob
 * @since 2021-06-22
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("xlk_institution")
public class Institution implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 组织结构id
     */
    @TableId(type = IdType.UUID)
    private String institutionId;

    /**
     * 组织代码
     */
    private String institutionCode;

    /**
     * 组织名称
     */
    private String institutionName;

    /**
     * 公司id
     */
    private Integer orgId;

    /**
     * 1是集团，2是区域子公司 3，是城市子公司
     */
    private Integer type;

    /**
     * 创建时间
     */
    private LocalDateTime createDate;


}
